' EPA Plugin to Access Perfmon Counters
' Created: 12/2/2007 Larry Morgan
' This script will make use of a parm file which will contain the metric names to be collected
'  
' The metrics that will be monitored are defined in the epaperfmon.properties file located in the same directory as the plugin
' Format of parms:
' Freq=15000   (amount of time between data retrieval
' Metric=xxxxxxxxxx  (example \Memory\Pages/sec or \\servername\Memory\Pages/sec- this line can occur multiple times)
dim metrics(200)
' This is where the parm file for the metrics is read
'
'nbrMetrics = 1
'metrics(1) = "\Memory\Pages/sec"
Set oArgs = WScript.Arguments
input_file_name = oArgs(0)
nbrMetrics = 0
Set objFSO1 = CreateObject("Scripting.FileSystemObject")
Set objInput = objFSO1.OpenTextFile(input_file_name, 1)
Do Until objInput.AtEndOfStream
	strLine = objInput.ReadLine
	If Left(strLine,1) <> "#" Then
		If Left(strLine,5) = "Freq=" Then
			freq = Trim(Right(strLine, Len(strLine)-5))
		End If
		If Left(strLine,7) = "Metric=" Then
			nbrMetrics = nbrMetrics + 1
			metrics(nbrMetrics) = Trim(Right(strLine, Len(strLine)-7))
		End If
	End If
Loop			
' End of parm file read
Do
For i = 1 to nbrMetrics
    Set objShell = WScript.CreateObject("WScript.Shell")
    Set objExecObject = objShell.Exec("typeperf """ & metrics(i) & """ -sc 1")
    nameDone = 0
    valueDone = 0
    perfFieldName  = ""
    perfFieldValue = 0
    Do While Not objExecObject.StdOut.AtEndOfStream
        strText = Trim(objExecObject.StdOut.ReadLine())
        If Len(strText) > 2 Then
            If mid(strText,2,1) = "(" Then
                strtName = InStr(strText, ",") + 2
                endName = Len(strText) - strtName
                perfFieldName = mid(strText, strtName, endName)
'                Wscript.Echo "line=" + perfFieldName
                nameDone = 1
            End If 
            If (nameDone = 1) and (mid(strText,2,1) <> "(") and InStr(strText, ",") > 0 Then
                strtValue = InStr(strText, ",") + 2
                endValue = Len(strText) - strtValue
                perfFieldValue = mid(strText, strtValue, endValue)
' Have to turn it into an integer
		If IsNumeric(perfFieldValue) Then 
      	
                		perfLongVal = Round(CDbl(perfFieldValue))
                		valueDone = 1
		End If
            End If
        End If
    Loop
    If (nameDone = 1) and (valueDone = 1) Then
' Format the name to work in Introscope
        formattedName = Replace(perfFieldName, ":", " ")
        formattedName = Replace(formattedName, "\", "|")
        formattedName = Replace(formattedName, "||", "|")
        formattedName = Replace(formattedName, "(", "|")
        formattedName = Replace(formattedName, ")", "")
	frontpart = Left(formattedName,InStrRev(formattedName, "|")-1)
        endpart = Right(formattedName, Len(formattedName)-Len(frontpart)-1)
        formattedName = frontpart + ":" + endpart
        Wscript.Echo "<metric type=""LongCounter"" name=""PerfMon" & formattedName &""" value=""" & CStr(perfLongVal) & """ />"
    End If
Next
Wscript.Sleep freq
Loop
